<template>
  <q-card v-if="variableset" bordered flat class="q-ma-sm q-pb-md variableset-card">
    <q-card-section class="text-bold">
      {{ formatted_id(variableset.name) }}
    </q-card-section>
    <div v-for="(variable, index) of variableset.variables" :key="index">
      <div class="row">
        <div class="col-3 label" role="rowheader">id</div>
        <div class="col-8 value detail_bg" role="cell">{{ formatted_id(variable.id) }}</div>
      </div>
      <div class="row">
        <div class="col-3 label" role="rowheader">type</div>
        <div class="col-8 value detail_bg" role="cell">{{ variable.type }}</div>
      </div>
      <div class="row">
        <div class="col-3 label" role="rowheader">bind as sequence</div>
        <div class="col-8 value detail_bg" role="cell">{{ variable.bind_as_sequence }}</div>
      </div>
      <div class="row" v-if="variable.variable_arc_name">
        <div class="col-3 label" role="rowheader">Arc-naam</div>
        <div class="col-8 value detail_bg" role="cell">{{ variable.variable_arc_name }}</div>
      </div>
      <div class="row" v-if="variable.select">
        <div class="col-3 label" role="rowheader">Select</div>
        <div class="col-8 value detail_bg" role="cell">{{ variable.select }}</div>
      </div>
      <div class="row" v-if="variable.matches">
        <div class="col-3 label" role="rowheader">Matches</div>
        <div class="col-8 value detail_bg" role="cell">{{ variable.matches }}</div>
      </div>
      <div class="row">
        <div class="col-3 label" role="rowheader">Nils</div>
        <div class="col-8 value detail_bg" role="cell">{{ variable.nils }}</div>
      </div>
      <div class="row" v-if="variable.fallback_value">
        <div class="col-3 label" role="rowheader">Select</div>
        <div class="col-8 value detail_bg" role="cell">{{ variable.fallback_value }}</div>
      </div>
      <div class="row" v-if="variable.order">
        <div class="col-3 label" role="rowheader">Order</div>
        <div class="col-8 value detail_bg" role="cell">{{ variable.order }}</div>
      </div>
      <div class="row" v-if="variable.priority">
        <div class="col-3 label" role="rowheader">Priority</div>
        <div class="col-8 value detail_bg" role="cell">{{ variable.priority }}</div>
      </div>
      <q-card-section v-if="variable.filters">
        <span class="text-bold q-ml-sm">Filters</span>
        <div v-for="(filter, f_index) of variable.filters" :key="f_index">
          <q-card flat bordered class="q-mb-md q-mt-sm q-mx-sm q-py-sm filter-card">
            <div class="row">
              <div class="col-3 label" role="rowheader">id</div>
              <div class="col-8 value detail_bg" role="cell">{{ formatted_id(filter.id) }}</div>
            </div>
            <div class="row">
              <div class="col-3 label" role="rowheader">type</div>
              <div class="col-8 value detail_bg" role="cell">{{ filter.type }}</div>
            </div>
            <div class="row" v-if="filter.aspect">
              <div class="col-3 label" role="rowheader">aspect</div>
              <div class="col-8 value detail_bg" role="cell">{{ filter.aspect }}</div>
            </div>
            <div class="row" v-if="filter.qname">
              <div class="col-3 label" role="rowheader">qname</div>
              <div class="col-8 value detail_bg" role="cell">{{ filter.qname }}</div>
            </div>
            <div class="row" v-if="filter.qname_expression">
              <div class="col-3 label" role="rowheader">qname expression</div>
              <div class="col-8 value detail_bg" role="cell">{{ filter.qname_expression }}</div>
            </div>
            <div class="row" v-if="filter.include_qname">
              <div class="col-3 label" role="rowheader">include qname</div>
              <div class="col-8 value detail_bg" role="cell">{{ filter.include_qname }}</div>
            </div>
            <div class="row" v-if="filter.exclude_qname">
              <div class="col-3 label" role="rowheader">exclude qname</div>
              <div class="col-8 value detail_bg" role="cell">{{ filter.exclude_qname }}</div>
            </div>
            <div class="row" v-if="filter.period_type">
              <div class="col-3 label" role="rowheader">period type</div>
              <div class="col-8 value detail_bg" role="cell">{{ filter.period_type }}</div>
            </div>
            <div class="row" v-if="filter.linkrole_role_uri">
              <div class="col-3 label" role="rowheader">role URI</div>
              <div class="col-8 value detail_bg" role="cell">{{ filter.linkrole_role_uri }}</div>
            </div>
            <div class="row" v-if="filter.axis">
              <div class="col-3 label" role="rowheader">axis</div>
              <div class="col-8 value detail_bg" role="cell">{{ filter.axis }}</div>
            </div>
            <div class="row" v-if="filter.balance_type">
              <div class="col-3 label" role="rowheader">balance type</div>
              <div class="col-8 value detail_bg" role="cell">{{ filter.balance_type }}</div>
            </div>
            <div class="row" v-if="filter.strict">
              <div class="col-3 label" role="rowheader">strict</div>
              <div class="col-8 value detail_bg" role="cell">{{ filter.strict }}</div>
            </div>
            <div class="row" v-if="filter.type_qname">
              <div class="col-3 label" role="rowheader">type Qname</div>
              <div class="col-8 value detail_bg" role="cell">{{ filter.type_qname }}</div>
            </div>
            <div class="row" v-if="filter.type_qname_expression">
              <div class="col-3 label" role="rowheader">type Qname expression</div>
              <div class="col-8 value detail_bg" role="cell">{{ filter.type_qname_expression }}</div>
            </div>
            <div class="row" v-if="filter.test">
              <div class="col-3 label" role="rowheader">test</div>
              <div class="col-8 value detail_bg" role="cell">{{ filter.test }}</div>
            </div>
            <div class="row" v-if="filter.boundary">
              <div class="col-3 label" role="rowheader">boundary</div>
              <div class="col-8 value detail_bg" role="cell">{{ filter.boundary }}</div>
            </div>
            <div class="row" v-if="filter.test">
              <div class="col-3 label" role="rowheader">test</div>
              <div class="col-8 value detail_bg" role="cell">{{ filter.test }}</div>
            </div>
          </q-card>

        </div>
      </q-card-section>
    </div>
  </q-card>
</template>

<script>
export default {
  name: "VariablesetDetailCard",
  props: {
    variableset: undefined
  },
  methods: {
    formatted_id: function (id) {
      return id.replaceAll("_", " ")
    }
  }
}
</script>

<style scoped lang="scss">
.value {
  border-radius: 5px;
  padding: 5px 0 5px 10px;
}

.row {
  padding: 5px 0 0 0;
}

.label {
  padding: 5px 0 5px 10px;
}

.filter-card {
  background-color: $lime-1;
}

</style>
